Index: /trunk/ArchTOIPipe/Kernel/piotoirdr.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/piotoirdr.cc	(revision 2391)
+++ /trunk/ArchTOIPipe/Kernel/piotoirdr.cc	(revision 2392)
@@ -3,5 +3,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: piotoirdr.cc,v 1.6 2003-05-20 10:10:08 aubourg Exp $
+// $Id: piotoirdr.cc,v 1.7 2003-05-28 21:03:19 aubourg Exp $
 
 #include "piotoirdr.h"
@@ -9,4 +9,6 @@
 extern void fits_lock();
 extern void fits_unlock();
+
+char** environ; // For darwin dylibs with piolib
 
 PIOTOIReader::PIOTOIReader(string grp, string obj, string flg) {
Index: /trunk/ArchTOIPipe/Kernel/ringprocessor.h
===================================================================
--- /trunk/ArchTOIPipe/Kernel/ringprocessor.h	(revision 2391)
+++ /trunk/ArchTOIPipe/Kernel/ringprocessor.h	(revision 2392)
@@ -5,5 +5,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: ringprocessor.h,v 1.2 2003-05-20 10:10:09 aubourg Exp $
+// $Id: ringprocessor.h,v 1.3 2003-05-28 21:03:19 aubourg Exp $
 
 
@@ -40,6 +40,6 @@
   virtual void run();
 
-  virtual int getMinRingIndex();
-  virtual int getMaxRingIndex();
+  virtual int getMinRingIndex() {return ringBegin;}
+  virtual int getMaxRingIndex() {return ringEnd;}
   virtual void setRingRange(int min, int max) {ringBegin=min; ringEnd=max;}
 
Index: /trunk/ArchTOIPipe/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/Makefile.in	(revision 2391)
+++ /trunk/ArchTOIPipe/Makefile.in	(revision 2392)
@@ -16,6 +16,6 @@
 USE_PIOLIB=@use_piolib@
 
-MACHEROS := $(shell echo `uname`)
-MACHDIR := $(MACHEROS)-$(CXX)
+UNAME := $(shell echo `uname`)
+MACHDIR := $(UNAME)-$(CXX)
 
 
@@ -23,18 +23,9 @@
  include $(DPCBASEREP)/Include/MakefileUser.h
 
- ifdef NOSHLIB
-  LIBF =  $(LIB)libSysTools.a $(LIB)libNTools.a $(LIB)libBlitz.a $(LIB)libFitsIOServer.a
-  LIBS :=  -L$(LIB)  -lSysTools -lNTools -lBlitz  $(LIBS)
-  ifeq ($(CXX),cxx)
-   # librairie des instances de templates cxx
-   LIBS := $(LIBS) -lrt
-  endif
- else
   LIBF =  $(SLB)libsophya.so 
   LIBS := -L$(SLB)  -lextsophya -lsophya $(LIBS)
-  ifeq ($(MACHEROS),OSF1)
+  ifeq ($(UNAME),OSF1)
    LIBS := $(LIBS) -lfor
   endif
- endif
  
  CPPFLAGS := -DWITH_SOPHYA $(CPPFLAGS)
@@ -48,6 +39,6 @@
 CPPFLAGS    :=  $(CPPFLAGS) @cfitsincdir@ -I. -DANSI 
 
-ifeq ($USE_PIOLIB,1)
-  PIOLIBS := @piolibdir@ -lpiolib
+ifeq ($(USE_PIOLIB),1)
+  PIOLIBS := -L@piolibdir@ -lpiolib
 else
   PIOLIBS :=
@@ -56,5 +47,5 @@
 LDLIBS=@cfitslibdir@ -lcfitsio $(PIOLIBS) $(LIBS) 
 
-ifeq ($(MACHEROS),IRIX64)
+ifeq ($(UNAME),IRIX64)
  ifeq ($(CXX), g++)
    LDLIBS=@cfitslibdir@ -lcfitsio -L /usr/lib32/
@@ -124,5 +115,5 @@
 # librairie compilateur GNU (g++)
 LIBGPP := -lstdc++
-ifeq ($(MACHEROS), Darwin)
+ifeq ($(UNAME), Darwin)
   LIBGPP := -L/sw/lib -ldl -L/usr/lib/gcc/darwin/default -lstdc++ -lcc_dynamic
 endif
@@ -172,5 +163,5 @@
 
 # Construction de shared-libs sous OSF1
-ifeq ($(MACHEROS),OSF1)
+ifeq ($(UNAME),OSF1)
   override CMDSHL := ld -shared -update_registry $(SLB)so_locations
   override FGSHLA := -all
@@ -194,5 +185,5 @@
 
 # Construction de shared-libs sous Linux
-ifeq ($(MACHEROS),Linux)
+ifeq ($(UNAME),Linux)
   override CMDSHL := ld -shared 
   override FGSHLA := --whole-archive
@@ -211,5 +202,5 @@
 
 # Construction de shared-libs sous Sun-OS
-ifeq ($(MACHEROS),SunOS)
+ifeq ($(UNAME),SunOS)
   override CMDSHL := ld -G
   override FGSHLA := -z allextract
@@ -221,5 +212,5 @@
 
 # Construction de shared-libs sous SGI
-ifeq ($(MACHEROS), IRIX64)
+ifeq ($(UNAME), IRIX64)
   override CMDSHL := ld -shared
   override FGSHLA := -all
@@ -234,5 +225,5 @@
 
 # Construction de shared-libs sous OSX
-ifeq ($(MACHEROS), Darwin)
+ifeq ($(UNAME), Darwin)
   override CMDSHL := libtool -dynamic
   override FGSHLA :=
@@ -240,9 +231,10 @@
   override TILSHL :=
   override CMDSHLCXX := libtool -dynamic
+  override FGSHLNCXX := 
 endif
 
 SLBNAME = libpipe.so
-ifeq ($(MACHEROS),Darwin)
-SLBNAME = libpipe.dylib
+ifeq ($(UNAME),Darwin)
+  SLBNAME = libpipe.dylib
 endif
 
@@ -252,6 +244,7 @@
 $(SLBNAME) : build_kernel build_processors build_sophya
 	$(CMDSHLCXX) -o $(SLBNAME)  \
-	Kernel/*.o Processors/*.o ProcWSophya/*.o \
+	Kernel/*.o Processors/*.o ProcWSophya/*.o $(PIOLIBS) \
 	$(FGSHLNCXX) -L$(SLB) -lsophya -lextsophya $(EXTLIB) $(LIBLSHL)
 
 
+
Index: /trunk/ArchTOIPipe/ProcWSophya/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 2391)
+++ /trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 2392)
@@ -48,5 +48,5 @@
 SRCFILES=map2toi.cc toi2map.cc rztoi.cc simtoipr.cc ktoibad.cc smoothtoi.cc \
          noisegen.cc meanvarestim.cc simoffset.cc simcleaner.cc flag2map.cc toi2toi_addsp.cc \
-	Bolos2ring.cc PSB2ring.cc toi2ring.cc ring2cout.cc
+	Bolos2ring.cc PSB2ring.cc toi2ring.cc ring2cout.cc ring33.cc
 
 FILES=$(patsubst %.c,%.o,$(SRCFILES:.cc=.o))