Index: trunk/SophyaExt/CodeMinuit/cfortran/Imakefile
===================================================================
--- trunk/SophyaExt/CodeMinuit/cfortran/Imakefile	(revision 2408)
+++ trunk/SophyaExt/CodeMinuit/cfortran/Imakefile	(revision 2408)
@@ -0,0 +1,17 @@
+#define IHaveSubdirs
+
+#ifndef CERNLIB_VAXVMS
+SUBDIRS= Examples
+#else
+SUBDIRS= $e$xamples
+#endif
+
+FILES=	cfortran.h \ @@\
+	comis.h cspack.h \ @@\
+	geant315.h geant321.h gen.h hbook.h higz.h hplot.h \ @@\
+	jetset74.h kernlib.h lapack.h lepto62.h minuit.h packlib.h paw.h \ @@\
+	graflib.h kuip.h zebra.h
+
+InstallIncludes($(FILES),$(CERN_INCLUDEDIR),cfortran)
+
+InstallIncludeSubdirs($(SUBDIRS))
Index: trunk/SophyaExt/CodeMinuit/cfortran/cfortran.h
===================================================================
--- trunk/SophyaExt/CodeMinuit/cfortran/cfortran.h	(revision 2407)
+++ trunk/SophyaExt/CodeMinuit/cfortran/cfortran.h	(revision 2408)
@@ -1,5 +1,5 @@
-/* cfortran.h  4.3 */
-/* www-zeus.desy.de/~burow   OR   anonymous ftp@zebra.desy.de */
-/* Burkhard Burow  burow@desy.de                 1990 - 1998. */
+/* cfortran.h  4.4_cernlib2002 */
+/* http://www-zeus.desy.de/~burow/cfortran/                   */
+/* Burkhard Burow  burow@desy.de                 1990 - 2002. */
 
 #ifndef __CFORTRAN_LOADED
@@ -269,5 +269,5 @@
 
 #ifndef apolloFortran
-#define COMMON_BLOCK_DEF(DEFINITION, NAME) extern DEFINITION NAME
+#define COMMON_BLOCK_DEF(DEFINITION, NAME) DEFINITION NAME
 #define CF_NULL_PROTO
 #else                                         /* HP doesn't understand #elif. */
@@ -652,6 +652,6 @@
           {0,DSC$K_DTYPE_T,DSC$K_CLASS_A,NULL,0,0,{0,0,1,1,1},1,0,NULL,0,{1,0}};
 #else
-#define     STRING_cfV(T,A,B,F) struct {unsigned int clen, flen;} B;
-#define    STRINGV_cfV(T,A,B,F) struct {char *s, *fs; unsigned flen;} B;
+#define     STRING_cfV(T,A,B,F) struct {unsigned int clen, flen; char *nombre;} B;
+#define    STRINGV_cfV(T,A,B,F) struct {char *s, *fs; unsigned flen; char *nombre;} B;
 #define    PSTRING_cfV(T,A,B,F) int     B;
 #define   PSTRINGV_cfV(T,A,B,F) struct{char *fs; unsigned int sizeofA,flen;}B;
@@ -771,5 +771,5 @@
 #define  LOGICAL_cfW(A,B)
 #define PLOGICAL_cfW(A,B) *B=F2CLOGICAL(*B);
-#define   STRING_cfW(A,B) (A[B.clen]!='\0'?A[B.clen]='\0':0); /* A?="constnt"*/
+#define   STRING_cfW(A,B) (B.nombre=A,B.nombre[B.clen]!='\0'?B.nombre[B.clen]='\0':0); /* A?="constnt"*/
 #define  PSTRING_cfW(A,B) kill_trailing(A,' ');
 #ifdef vmsFortran
@@ -1674,7 +1674,7 @@
        memset((A)+B.dsc$w_length,' ',C-B.dsc$w_length-1), B.dsc$w_length=C-1));
 #else
-#define   STRING_cfC(M,I,A,B,C) (B.clen=strlen(A),                             \
+#define   STRING_cfC(M,I,A,B,C) (B.nombre=A,B.clen=strlen(A),                             \
                 C==sizeof(char*)||C==(unsigned)(B.clen+1)?B.flen=B.clen:       \
-                        (memset((A)+B.clen,' ',C-B.clen-1),A[B.flen=C-1]='\0'));
+                        (memset(B.nombre+B.clen,' ',C-B.clen-1),B.nombre[B.flen=C-1]='\0'));
 #define  PSTRING_cfC(M,I,A,B,C) (C==sizeof(char*)? B=strlen(A):                \
                     (A[C-1]='\0',B=strlen(A),memset((A)+B,' ',C-B-1),B=C-1));
Index: trunk/SophyaExt/CodeMinuit/cfortran/lapack.h
===================================================================
--- trunk/SophyaExt/CodeMinuit/cfortran/lapack.h	(revision 2408)
+++ trunk/SophyaExt/CodeMinuit/cfortran/lapack.h	(revision 2408)
@@ -0,0 +1,2 @@
+PROTOCCALLSFSUB11(DGELS,dgels,STRING,INT,INT,INT,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,INT,PINT)
+#define DGELS(TRANS,M,N,NRHS,A,LDA,B,LDB,WORK,LWORK,INFO) CCALLSFSUB11(DGELS,dgels,STRING,INT,INT,INT,DOUBLEV,INT,DOUBLEV,INT,DOUBLEV,INT,PINT,TRANS,M,N,NRHS,A,LDA,B,LDB,WORK,LWORK,INFO)
Index: trunk/SophyaExt/CodeMinuit/cfortran/paw.h
===================================================================
--- trunk/SophyaExt/CodeMinuit/cfortran/paw.h	(revision 2408)
+++ trunk/SophyaExt/CodeMinuit/cfortran/paw.h	(revision 2408)
@@ -0,0 +1,6 @@
+PROTOCCALLSFSUB2(PAW,paw,INT,INT)
+#define PAW(A1,A2)  CCALLSFSUB2(PAW,paw,INT,INT,A1,A2)
+
+PROTOCCALLSFSUB0(PAEXIT,paexit)
+#define PAEXIT() CCALLSFSUB0(PAEXIT,paexit)
+