Index: trunk/SophyaLib/Manual/piapp.tex
===================================================================
--- trunk/SophyaLib/Manual/piapp.tex	(revision 2416)
+++ trunk/SophyaLib/Manual/piapp.tex	(revision 2437)
@@ -85,6 +85,6 @@
 a copy of the on-line help (accessible through the menu {\tt File/Help}). 
 Once the SOPHYA/piapp (or PEIDA++/piapp) environment 
-\footnote{ The environment variables {\tt DPCBASEREP} (or {\tt EROSBASEREP}),
-{\tt EROSCXX} (compiler selector), the shared library path 
+\footnote{ The environment variables {\tt SOPHYABASEREP} (or {\tt EROSBASEREP}),
+{\tt SOPHYACXX} (compiler selector), the shared library path 
 {\tt LD\_LIBRARY\_PATH} and the executable search path {\tt PATH} must
 be defined}
Index: trunk/SophyaLib/Manual/sophya.tex
===================================================================
--- trunk/SophyaLib/Manual/sophya.tex	(revision 2416)
+++ trunk/SophyaLib/Manual/sophya.tex	(revision 2437)
@@ -174,8 +174,8 @@
 
 \subsection{Environment variables}
-Two environment variables {\bf DPCBASEREP} and {\bf EROSCXX} are used 
+Two environment variables {\bf SOPHYABASEREP} and {\bf SOPHYACXX} are used 
 to define the path where the Sophya libraries and executable are installed.
-{\bf DPCBASEREP} defines the base directory path and {\bf EROSCXX} the 
-name of the C++ compiler. The complete path is built using {\bf DPCBASEREP},
+{\bf SOPHYABASEREP} defines the base directory path and {\bf SOPHYACXX} the 
+name of the C++ compiler. The complete path is built using {\bf SOPHYABASEREP},
 the operating system name (as obtained by the {\tt uname} command), and
 the compiler name. In the example below, we show the complete path 
@@ -183,13 +183,13 @@
 
 \begin{itemize}
-\item \$DPCBASEREP/Include : Include (.h) files
-\item \$DPCBASEREP/Linux-g++/Libs : Path for the archive libraries (.a)
-\item \$DPCBASEREP/Linux-g++/ShLibs : Shared library path (.so)
-\item \$DPCBASEREP/Linux-g++/Exec : Executable file path
+\item \$SOPHYABASEREP/Include : Include (.h) files
+\item \$SOPHYABASEREP/Linux-g++/Libs : Path for the archive libraries (.a)
+\item \$SOPHYABASEREP/Linux-g++/ShLibs : Shared library path (.so)
+\item \$SOPHYABASEREP/Linux-g++/Exec : Executable file path
 \end{itemize}
 
 In order to use the shared libraries, the {\bf LD\_LIBRARY\_PATH} variable
 should contain the Sophya shared library path 
-({\tt \$DPCBASEREP/Linux-g++/ShLibs } when using g++ compiler on Linux)
+({\tt \$SOPHYABASEREP/Linux-g++/ShLibs } when using g++ compiler on Linux)
 
 For modules using external libraries, the {\bf EXTLIBDIR} 
@@ -203,10 +203,10 @@
 
 \subsection{User makefiles}
-The file {\tt \$DPCBASEREP/Include/MakefileUser.h} defines the compilation 
+The file {\tt \$SOPHYABASEREP/Include/MakefileUser.h} defines the compilation 
 flags and the list of Sophya libraries. It should be included in the 
 user's makefile. The default compilation rules assumes that the object (.o) 
 and executable files would be put in the following directories: \\
-{\tt \$HOME/`uname`-\$EROSCXX/Objs} \\ 
-{\tt \$HOME/`uname`-\$EROSCXX/Exec}.
+{\tt \$HOME/`uname`-\$SOPHYACXX/Objs} \\ 
+{\tt \$HOME/`uname`-\$SOPHYACXX/Exec}.
 In the case of a {\tt Linux} system and using {\tt g++} as the C++ compiler, 
 these two directories would be translated to \\
@@ -1517,5 +1517,5 @@
 The build procedure expects to find the include files and the libraries in: \\
 {\tt \$EXTLIBDIR/Include/FitsIO } \\
-{\tt \$EXTLIBDIR/`uname`-\$EROSCXX/Libs} \\
+{\tt \$EXTLIBDIR/`uname`-\$SOPHYACXX/Libs} \\
 The complete directory tree content for the various external libraries used 
 by this version of SOPHYA is listed below:
@@ -1544,5 +1544,5 @@
 grouped in ({\tt libPI.so}).
 
-The environment variables {\bf DPCDEVREP}, {\bf EXTLIBDIR} and {\bf EROSCXX}
+The environment variables {\bf SOPHYADEVREP}, {\bf EXTLIBDIR} and {\bf SOPHYACXX}
 must be defined in order to install the Sophya package.
 In the example below, we assume that we want to install Sophya from a 
@@ -1559,8 +1559,8 @@
 \begin{verbatim}
 # We select our C++ compiler
-csh> setenv EROSCXX g++
+csh> setenv SOPHYACXX g++
 # Setup the build directory
 csh> mkdir /usr/local/Sophya/
-csh> setenv DPCDEVREP /usr/local/Sophya/
+csh> setenv SOPHYADEVREP /usr/local/Sophya/
 csh> setenv EXTLIBDIR /usr/local/ExtLibs/
 # Use the top level makefile in Mgr/ 
@@ -1620,9 +1620,9 @@
 for the different compilers and systems. (to be included in makefiles)
 \item {\bf crerep\_sophya} c-shell script for creating the directory tree
-under {\tt \$DPCBASEREP} and {\tt \$DPCDEVREP}
+under {\tt \$SOPHYABASEREP} and {\tt \$SOPHYADEVREP}
 \item {\bf install\_sophya} c-shell script for installing the Sophya package.
-Usually from {\tt \$DPCDEVREP} to {\tt \$DPCBASEREP}
+Usually from {\tt \$SOPHYADEVREP} to {\tt \$SOPHYABASEREP}
 \item {\bf mkmflien} c-shell script for making symbolic links or copying
-include files to {\tt \$DPCDEVREP/Include} or {\tt \$DPCBASEREP/Include}
+include files to {\tt \$SOPHYADEVREP/Include} or {\tt \$SOPHYABASEREP/Include}
 \item {\bf mkmf} c-shell script for generating module makefiles and the 
 top level makefile (named GNUmakefile)